[points_cl,header] = xlsread('miRNA-Combine-New.xlsx','miRNA-Combine-296-001');
accuracyFile = 'getAccuracyofFeatureLevel1EnsembleRF.xlsx';
featureFile = 'feastFeaturesLevel1EnsembleRF.xlsx';
fold = 10;
points = points_cl(:,1:end-1);
cl = points_cl(:,end);
points(isnan(points))=0;
%points = normalize(points); % Normalize using  z-score of the data in A with center 0 and standard deviation 1


miRNA = header(1,2:end);
patient = header(2:end,1);
method = {'RF'};
featureMETHOD = {'MIM', 'MRMR', 'CMIM', 'JMI', 'DISR','CIFE', 'ICAP', 'CONDRED'};
%numberOfFeature = 50;
accMIM = [];
accMRMR = [];
accCMIM = [];
accJMI = [];
accDISR = [];
accCIFE = [];
accICAP = [];
accCONDRED = [];

summaryHeader = {};
count = 0;

for i = 10:10:290
    count = count + 1;
    fprintf('Processing for ... %d\n',i);    
    accSheet = strcat(num2str(i),'_MIRNA');
    summaryHeader{count} = accSheet;

    fprintf('Processing MIM ....\n');
    [mimFeatures] = feast('mim',i,points,cl);
    expressData = points(:,sort(mimFeatures));
    expressDatawithLabel = [expressData cl];
    [acc] = CrossFoldTBnew(expressDatawithLabel, fold);
    accMIM = [accMIM acc];

    fprintf('Processing MRMR ....\n');
    [mrmrFeatures] = feast('mrmr',i,points,cl);
    expressData = points(:,sort(mrmrFeatures));
    expressDatawithLabel = [expressData cl];
    [acc] = CrossFoldTBnew(expressDatawithLabel, fold);
    accMRMR = [accMRMR acc];

    fprintf('Processing CMIM ....\n');
    [cmimFeatures] = feast('cmim',i,points,cl);
    expressData = points(:,sort(cmimFeatures));
    expressDatawithLabel = [expressData cl];
    [acc] = CrossFoldTBnew(expressDatawithLabel, fold);
    accCMIM = [accCMIM acc];

    fprintf('Processing JMI ....\n');
    [jmiFeatures] = feast('jmi',i,points,cl);
    expressData = points(:,sort(jmiFeatures));
    expressDatawithLabel = [expressData cl];
    [acc] = CrossFoldTBnew(expressDatawithLabel, fold);
    accJMI = [accJMI acc];

    fprintf('Processing DISR ....\n');
    [disrFeatures] = feast('disr',i,points,cl);
    expressData = points(:,sort(disrFeatures));
    expressDatawithLabel = [expressData cl];
    [acc] = CrossFoldTBnew(expressDatawithLabel, fold);
    accDISR = [accDISR acc];


    fprintf('Processing CIFE ....\n');
    [cifeFeatures] = feast('cife',i,points,cl);
    expressData = points(:,sort(cifeFeatures));
    expressDatawithLabel = [expressData cl];
    [acc] = CrossFoldTBnew(expressDatawithLabel, fold);
    accCIFE = [accCIFE acc];

    fprintf('Processing ICAP ....\n');
    [icapFeatures] = feast('icap',i,points,cl);
    expressData = points(:,sort(icapFeatures));
    expressDatawithLabel = [expressData cl];
    [acc] = CrossFoldTBnew(expressDatawithLabel, fold);
    accICAP = [accICAP acc];

    fprintf('Processing CONDRED ....\n');
    [condredFeatures] = feast('condred',i,points,cl);
    expressData = points(:,sort(condredFeatures));
    expressDatawithLabel = [expressData cl];
    [acc] = CrossFoldTBnew(expressDatawithLabel, fold);
    accCONDRED = [accCONDRED acc];

    fprintf('Generating feature index....\n');
    rankSheet = strcat('occurrence',num2str(i));
    allMethodSheet = strcat('allmethods',num2str(i));
    allMethodFeature = [mimFeatures mrmrFeatures cmimFeatures jmiFeatures disrFeatures cifeFeatures icapFeatures condredFeatures];
    xlswrite(featureFile,featureMETHOD,allMethodSheet,'A1');
    xlswrite(featureFile,allMethodFeature,allMethodSheet,'A2');
    uniqueIdx = unique(allMethodFeature);
    idxOccure = [uniqueIdx,histc(allMethodFeature(:),uniqueIdx)];
    sortedIdxOccure = sortrows(idxOccure,2,'descend');
    xlswrite(featureFile,sortedIdxOccure, rankSheet);

end
xlswrite(accuracyFile,summaryHeader,'MIM','B1');
xlswrite(accuracyFile,method,'MIM','A2');
xlswrite(accuracyFile,accMIM,'MIM','B2');

xlswrite(accuracyFile,summaryHeader,'MRMR','B1');
xlswrite(accuracyFile,method,'MRMR','A2');
xlswrite(accuracyFile,accMRMR,'MRMR','B2');

xlswrite(accuracyFile,summaryHeader,'CMIM','B1');
xlswrite(accuracyFile,method,'CMIM','A2');
xlswrite(accuracyFile,accCMIM,'CMIM','B2');

xlswrite(accuracyFile,summaryHeader,'JMI','B1');
xlswrite(accuracyFile,method,'JMI','A2');
xlswrite(accuracyFile,accJMI,'JMI','B2');

xlswrite(accuracyFile,summaryHeader,'DISR','B1');
xlswrite(accuracyFile,method,'DISR','A2');
xlswrite(accuracyFile,accDISR,'DISR','B2');

xlswrite(accuracyFile,summaryHeader,'CIFE','B1');
xlswrite(accuracyFile,method,'CIFE','A2');
xlswrite(accuracyFile,accCIFE,'CIFE','B2');

xlswrite(accuracyFile,summaryHeader,'ICAP','B1');
xlswrite(accuracyFile,method,'ICAP','A2');
xlswrite(accuracyFile,accICAP,'ICAP','B2');

xlswrite(accuracyFile,summaryHeader,'CONDRED','B1');
xlswrite(accuracyFile,method,'CONDRED','A2');
xlswrite(accuracyFile,accCONDRED,'CONDRED','B2');

xlswrite(accuracyFile,summaryHeader,'summary','B1');
xlswrite(accuracyFile,featureMETHOD,'summary','A2');
xlswrite(accuracyFile,[accMIM;accMRMR;accCMIM;accJMI;accDISR;accCIFE;accICAP;accCONDRED],'summary','B2');
