featureFile = 'featureselectlevel1.xlsx';
fprintf('Reading files ...\n');
[mim_points,mim_header] = xlsread(featureFile,'miRNA','A:A');
[mrmr_points,mrmr_header] = xlsread(featureFile,'miRNA','B:B');
[cmim_points,cmim_header] = xlsread(featureFile,'miRNA','C:C');
[jmi_points,jmi_header] = xlsread(featureFile,'miRNA','D:D');
[disr_points,disr_header] = xlsread(featureFile,'miRNA','E:E');
[cife_points,cife_header] = xlsread(featureFile,'miRNA','F:F');
[icap_points,icap_header] = xlsread(featureFile,'miRNA','G:G');
[condred_points,condred_header] = xlsread(featureFile,'miRNA','H:H');

combined_points = [mim_points;mrmr_points;cmim_points;jmi_points;disr_points;cife_points;icap_points;condred_points];
uniqueIdx = unique(combined_points);
idxOccure = [uniqueIdx,histc(combined_points,uniqueIdx)];
sortedIdxOccure = sortrows(idxOccure,2,'descend');
fprintf('Saving sorted index ...\n'); 
xlswrite(featureFile,sortedIdxOccure, 'occurance');

fprintf('Selecting features upto 3 star ...\n'); 
upto3star = sortedIdxOccure(find(sortedIdxOccure(:,2)>=3),:);

fprintf('Executing RF for different subset of features ...\n');
[points_cl,header] = xlsread('miRNA-Combine-New.xlsx','miRNA-Combine-296-001');
fold = 10;
points = points_cl(:,1:end-1);
cl = points_cl(:,end);
points(isnan(points))=0;
miRNA = header(1,2:end);
patient = header(2:end,1);
method = {'RF'};
accRF = [];
summaryHeader = {};
count = 0;

for i = 10:size(upto3star,1)
%for i = 10:13
    count = count + 1;
    fprintf('Processing for ... %d miRNAs\n',i);    
    accSheet = strcat(num2str(i),'_MIRNA');
    summaryHeader{count} = accSheet;
    expressData = points(:,sort(upto3star(1:i,1)));
    expressDatawithLabel = [expressData cl];
    [acc] = CrossFoldTBnew(expressDatawithLabel, fold);
    accRF = [accRF acc];
end

xlswrite(featureFile,summaryHeader','Accuracy','A2');
xlswrite(featureFile,method,'Accuracy','B1');
xlswrite(featureFile,accRF','Accuracy','B2');


