[points_cl,header] = xlsread('mirseq_BRCA_mature_RPM_tumour_normal_log2.xlsx','mirseq_log2');
maxITR = 1;
points = points_cl(:,1:end-1);
cl = points_cl(:,end);
points(isnan(points))=0;
miRNA = header(1,2:end-1);
patient = header(2:end,1);
method = {'SVM'; 'ANN'; 'KNN'; 'DT'; 'TB'; 'NB'; 'DISCR'};
header = {'30_MIRNA', '40_MIRNA', '50_MIRNA', '60_MIRNA'};
% cl= xlsread('miRNA-All-Kidney-Cancer-L2.xlsx','Label');

mimFeatures30 = [];
mimFeatures40 = [];
mimFeatures50 = [];
mimFeatures50 = [];
accMIM30 = [];
accMIM40 = [];
accMIM50 = [];
accMIM60 = [];

mrmrFeatures30 = [];
mrmrFeatures40 = [];
mrmrFeatures50 = [];
mrmrFeatures50 = [];
accMRMR30 = [];
accMRMR40 = [];
accMRMR50 = [];
accMRMR60 = [];

cmimFeatures30 = [];
cmimFeatures40 = [];
cmimFeatures50 = [];
cmimFeatures50 = [];
accCMIM30 = [];
accCMIM40 = [];
accCMIM50 = [];
accCMIM60 = [];

jmiFeatures30 = [];
jmiFeatures40 = [];
jmiFeatures50 = [];
jmiFeatures50 = [];
accJMI30 = [];
accJMI40 = [];
accJMI50 = [];
accJMI60 = [];

disrFeatures30 = [];
disrFeatures40 = [];
disrFeatures50 = [];
disrFeatures50 = [];
accDISR30 = [];
accDISR40 = [];
accDISR50 = [];
accDISR60 = [];

cifeFeatures30 = [];
cifeFeatures40 = [];
cifeFeatures50 = [];
cifeFeatures50 = [];
accCIFE30 = [];
accCIFE40 = [];
accCIFE50 = [];
accCIFE60 = [];

icapFeatures30 = [];
icapFeatures40 = [];
icapFeatures50 = [];
icapFeatures50 = [];
accICAP30 = [];
accICAP40 = [];
accICAP50 = [];
accICAP60 = [];

condredFeatures30 = [];
condredFeatures40 = [];
condredFeatures50 = [];
condredFeatures50 = [];
accCONDRED30 = [];
accCONDRED40 = [];
accCONDRED50 = [];
accCONDRED60 = [];
%MIM
for i = 1:maxITR

    i
    fprintf("Processing MIM 30....\n");
    [mimFeatures30(i,:)] = feast('mim',30,points,cl);
    expressData = points(:,sort(mimFeatures30));
    expressDatawithLabel = [expressData cl];
    [accMIM30(i,:)] = CrossFoldANNnew(expressDatawithLabel, 10);

    fprintf("Processing MIM 40....\n");
    [mimFeatures40(i,:)] = feast('mim',40,points,cl);
    expressData = points(:,sort(mimFeatures40));
    expressDatawithLabel = [expressData cl];
    [accMIM40(i,:)] = CrossFoldANNnew(expressDatawithLabel, 10);

    fprintf("Processing MIM 50....\n");
    [mimFeatures50(i,:)] = feast('mim',50,points,cl);
    expressData = points(:,sort(mimFeatures50));
    expressDatawithLabel = [expressData cl];
    [accMIM50(i,:)] = CrossFoldANNnew(expressDatawithLabel, 10);

    fprintf("Processing MIM 60....\n");
    [mimFeatures60(i,:)] = feast('mim',60,points,cl);
    expressData = points(:,sort(mimFeatures60));
    expressDatawithLabel = [expressData cl];
    [accMIM60(i,:)] = CrossFoldANNnew(expressDatawithLabel, 10);
end

result30 = [mimFeatures30 accMIM30];
result40 = [mimFeatures40 accMIM40];
result50 = [mimFeatures50 accMIM50];
result60 = [mimFeatures60 accMIM60];

xlswrite('MIM.xlsx',result30,'30','A1');
xlswrite('MIM.xlsx',result40,'40','A1');
xlswrite('MIM.xlsx',result50,'50','A1');
xlswrite('MIM.xlsx',result60,'60','A1');

%MRMR
for i = 1:maxITR
i
    fprintf("Processing MRMR 30....\n");
    [mrmrFeatures30(i,:)] = feast('mrmr',30,points,cl);
    expressData = points(:,sort(mrmrFeatures30));
    expressDatawithLabel = [expressData cl];
    [accMRMR30(i,:)] = CrossFoldANNnew(expressDatawithLabel, 10);

    fprintf("Processing MRMR 40....\n");
    [mrmrFeatures40(i,:)] = feast('mrmr',40,points,cl);
    expressData = points(:,sort(mrmrFeatures40));
    expressDatawithLabel = [expressData cl];
    [accMRMR40(i,:)] = CrossFoldANNnew(expressDatawithLabel, 10);

    fprintf("Processing MRMR 50....\n");
    [mrmrFeatures50(i,:)] = feast('mrmr',50,points,cl);
    expressData = points(:,sort(mrmrFeatures50));
    expressDatawithLabel = [expressData cl];
    [accMRMR50(i,:)] = CrossFoldANNnew(expressDatawithLabel, 10);

    fprintf("Processing MRMR 60....\n");
    [mrmrFeatures60(i,:)] = feast('mrmr',60,points,cl);
    expressData = points(:,sort(mrmrFeatures60));
    expressDatawithLabel = [expressData cl];
    [accMRMR60(i,:)] = CrossFoldANNnew(expressDatawithLabel, 10);
end

result30 = [mrmrFeatures30 accMRMR30];
result40 = [mrmrFeatures40 accMRMR40];
result50 = [mrmrFeatures50 accMRMR50];
result60 = [mrmrFeatures60 accMRMR60];

xlswrite('MRMR.xlsx',result30,'30','A1');
xlswrite('MRMR.xlsx',result40,'40','A1');
xlswrite('MRMR.xlsx',result50,'50','A1');
xlswrite('MRMR.xlsx',result60,'60','A1');


%CMIM
for i = 1:maxITR
i

    fprintf("Processing CMIM 30....\n");
    [cmimFeatures30(i,:)] = feast('cmim',30,points,cl);
    expressData = points(:,sort(cmimFeatures30));
    expressDatawithLabel = [expressData cl];
    [accCMIM30(i,:)] = CrossFoldANNnew(expressDatawithLabel, 10);

    fprintf("Processing CMIM 40....\n");
    [cmimFeatures40(i,:)] = feast('cmim',40,points,cl);
    expressData = points(:,sort(cmimFeatures40));
    expressDatawithLabel = [expressData cl];
    [accCMIM40(i,:)] = CrossFoldANNnew(expressDatawithLabel, 10);

    fprintf("Processing CMIM 50....\n");
    [cmimFeatures50(i,:)] = feast('cmim',50,points,cl);
    expressData = points(:,sort(cmimFeatures50));
    expressDatawithLabel = [expressData cl];
    [accCMIM50(i,:)] = CrossFoldANNnew(expressDatawithLabel, 10);

    fprintf("Processing CMIM 60....\n");
    [cmimFeatures60(i,:)] = feast('cmim',60,points,cl);
    expressData = points(:,sort(cmimFeatures60));
    expressDatawithLabel = [expressData cl];
    [accCMIM60(i,:)] = CrossFoldANNnew(expressDatawithLabel, 10);

end

result30 = [cmimFeatures30 accCMIM30];
result40 = [cmimFeatures40 accCMIM40];
result50 = [cmimFeatures50 accCMIM50];
result60 = [cmimFeatures60 accCMIM60];

xlswrite('CMIM.xlsx',result30,'30','A1');
xlswrite('CMIM.xlsx',result40,'40','A1');
xlswrite('CMIM.xlsx',result50,'50','A1');
xlswrite('CMIM.xlsx',result60,'60','A1');

%JMI
for i = 1:maxITR
i

    fprintf("Processing JMI 30....\n");
    [jmiFeatures30(i,:)] = feast('jmi',30,points,cl);
    expressData = points(:,sort(jmiFeatures30));
    expressDatawithLabel = [expressData cl];
    [accJMI30(i,:)] = CrossFoldANNnew(expressDatawithLabel, 10);

    fprintf("Processing JMI 40....\n");
    [jmiFeatures40(i,:)] = feast('jmi',40,points,cl);
    expressData = points(:,sort(jmiFeatures40));
    expressDatawithLabel = [expressData cl];
    [accJMI40(i,:)] = CrossFoldANNnew(expressDatawithLabel, 10);

    fprintf("Processing JMI 50....\n");
    [jmiFeatures50(i,:)] = feast('jmi',50,points,cl);
    expressData = points(:,sort(jmiFeatures50));
    expressDatawithLabel = [expressData cl];
    [accJMI50(i,:)] = CrossFoldANNnew(expressDatawithLabel, 10);

    fprintf("Processing JMI 60....\n");
    [jmiFeatures60(i,:)] = feast('jmi',60,points,cl);
    expressData = points(:,sort(jmiFeatures60));
    expressDatawithLabel = [expressData cl];
    [accJMI60(i,:)] = CrossFoldANNnew(expressDatawithLabel, 10);

end

result30 = [jmiFeatures30 accJMI30];
result40 = [jmiFeatures40 accJMI40];
result50 = [jmiFeatures50 accJMI50];
result60 = [jmiFeatures60 accJMI60];

xlswrite('JMI.xlsx',result30,'30','A1');
xlswrite('JMI.xlsx',result40,'40','A1');
xlswrite('JMI.xlsx',result50,'50','A1');
xlswrite('JMI.xlsx',result60,'60','A1');


%DISR
for i = 1:maxITR
i

fprintf("Processing DISR 30....\n");
[disrFeatures30(i,:)] = feast('disr',30,points,cl);
expressData = points(:,sort(disrFeatures30));
expressDatawithLabel = [expressData cl];
[accDISR30(i,:)] = CrossFoldANNnew(expressDatawithLabel, 10);

fprintf("Processing DISR 40....\n");
[disrFeatures40(i,:)] = feast('disr',40,points,cl);
expressData = points(:,sort(disrFeatures40));
expressDatawithLabel = [expressData cl];
[accDISR40(i,:)] = CrossFoldANNnew(expressDatawithLabel, 10);

fprintf("Processing DISR 50....\n");
[disrFeatures50(i,:)] = feast('disr',50,points,cl);
expressData = points(:,sort(disrFeatures50));
expressDatawithLabel = [expressData cl];
[accDISR50(i,:)] = CrossFoldANNnew(expressDatawithLabel, 10);

fprintf("Processing DISR 60....\n");
[disrFeatures60(i,:)] = feast('disr',60,points,cl);
expressData = points(:,sort(disrFeatures60));
expressDatawithLabel = [expressData cl];
[accDISR60(i,:)] = CrossFoldANNnew(expressDatawithLabel, 10);

end

result30 = [disrFeatures30 accDISR30];
result40 = [disrFeatures40 accDISR40];
result50 = [disrFeatures50 accDISR50];
result60 = [disrFeatures60 accDISR60];

xlswrite('DISR.xlsx',result30,'30','A1');
xlswrite('DISR.xlsx',result40,'40','A1');
xlswrite('DISR.xlsx',result50,'50','A1');
xlswrite('DISR.xlsx',result60,'60','A1');

%CIFE
for i = 1:maxITR
i

    fprintf("Processing CIFE 30....\n");
    [cifeFeatures30(i,:)] = feast('cife',30,points,cl);
    expressData = points(:,sort(cifeFeatures30));
    expressDatawithLabel = [expressData cl];
    [accCIFE30(i,:)] = CrossFoldANNnew(expressDatawithLabel, 10);

    fprintf("Processing CIFE 40....\n");
    [cifeFeatures40(i,:)] = feast('cife',40,points,cl);
    expressData = points(:,sort(cifeFeatures40));
    expressDatawithLabel = [expressData cl];
    [accCIFE40(i,:)] = CrossFoldANNnew(expressDatawithLabel, 10);

    fprintf("Processing CIFE 50....\n");
    [cifeFeatures50(i,:)] = feast('cife',50,points,cl);
    expressData = points(:,sort(cifeFeatures50));
    expressDatawithLabel = [expressData cl];
    [accCIFE50(i,:)] = CrossFoldANNnew(expressDatawithLabel, 10);

    fprintf("Processing CIFE 60....\n");
    [cifeFeatures60(i,:)] = feast('cife',60,points,cl);
    expressData = points(:,sort(cifeFeatures60));
    expressDatawithLabel = [expressData cl];
    [accCIFE60(i,:)] = CrossFoldANNnew(expressDatawithLabel, 10);

end

result30 = [cifeFeatures30 accCIFE30];
result40 = [cifeFeatures40 accCIFE40];
result50 = [cifeFeatures50 accCIFE50];
result60 = [cifeFeatures60 accCIFE60];

xlswrite('CIFE.xlsx',result30,'30','A1');
xlswrite('CIFE.xlsx',result40,'40','A1');
xlswrite('CIFE.xlsx',result50,'50','A1');
xlswrite('CIFE.xlsx',result60,'60','A1');

%ICAP
for i = 1:maxITR
i

    fprintf("Processing ICAP 30....\n");
    [icapFeatures30(i,:)] = feast('icap',30,points,cl);
    expressData = points(:,sort(icapFeatures30));
    expressDatawithLabel = [expressData cl];
    [accICAP30(i,:)] = CrossFoldANNnew(expressDatawithLabel, 10);

    fprintf("Processing ICAP 40....\n");
    [icapFeatures40(i,:)] = feast('icap',40,points,cl);
    expressData = points(:,sort(icapFeatures40));
    expressDatawithLabel = [expressData cl];
    [accICAP40(i,:)] = CrossFoldANNnew(expressDatawithLabel, 10);

    fprintf("Processing ICAP 50....\n");
    [icapFeatures50(i,:)] = feast('icap',50,points,cl);
    expressData = points(:,sort(icapFeatures50));
    expressDatawithLabel = [expressData cl];
    [accICAP50(i,:)] = CrossFoldANNnew(expressDatawithLabel, 10);

    fprintf("Processing ICAP 60....\n");
    [icapFeatures60(i,:)] = feast('icap',60,points,cl);
    expressData = points(:,sort(icapFeatures60));
    expressDatawithLabel = [expressData cl];
    [accICAP60(i,:)] = CrossFoldANNnew(expressDatawithLabel, 10);

end

result30 = [icapFeatures30 accICAP30];
result40 = [icapFeatures40 accICAP40];
result50 = [icapFeatures50 accICAP50];
result60 = [icapFeatures60 accICAP60];

xlswrite('ICAP.xlsx',result30,'30','A1');
xlswrite('ICAP.xlsx',result40,'40','A1');
xlswrite('ICAP.xlsx',result50,'50','A1');
xlswrite('ICAP.xlsx',result60,'60','A1');


%CONDRED
for i = 1:maxITR
i

    fprintf("Processing CONDRED 30....\n");
    [condredFeatures30(i,:)] = feast('condred',30,points,cl);
    expressData = points(:,sort(condredFeatures30));
    expressDatawithLabel = [expressData cl];
    [accCONDRED30(i,:)] = CrossFoldANNnew(expressDatawithLabel, 10);

    fprintf("Processing CONDRED 40....\n");
    [condredFeatures40(i,:)] = feast('condred',40,points,cl);
    expressData = points(:,sort(condredFeatures40));
    expressDatawithLabel = [expressData cl];
    [accCONDRED40(i,:)] = CrossFoldANNnew(expressDatawithLabel, 10);

    fprintf("Processing CONDRED 50....\n");
    [condredFeatures50(i,:)] = feast('condred',50,points,cl);
    expressData = points(:,sort(condredFeatures50));
    expressDatawithLabel = [expressData cl];
    [accCONDRED50(i,:)] = CrossFoldANNnew(expressDatawithLabel, 10);

    fprintf("Processing CONDRED 60....\n");
    [condredFeatures60(i,:)] = feast('condred',60,points,cl);
    expressData = points(:,sort(condredFeatures60));
    expressDatawithLabel = [expressData cl];
    [accCONDRED60(i,:)] = CrossFoldANNnew(expressDatawithLabel, 10);

end

result30 = [condredFeatures30 accCONDRED30];
result40 = [condredFeatures40 accCONDRED40];
result50 = [condredFeatures50 accCONDRED50];
result60 = [condredFeatures60 accCONDRED60];

xlswrite('CONDRED.xlsx',result30,'30','A1');
xlswrite('CONDRED.xlsx',result40,'40','A1');
xlswrite('CONDRED.xlsx',result50,'50','A1');
xlswrite('CONDRED.xlsx',result60,'60','A1');
