[points,header] = xlsread('miRNA-All-Kidney-Cancer-L2.xlsx','miRNA-All-Kidney-Cancer');
points(isnan(points))=0;
miRNA = header(1,2:end);
patient = header(2:end,1);
cl= xlsread('miRNA-All-Kidney-Cancer-L2.xlsx','Label');
[mimFeatures50] = feast('mim',50,points,cl);
[mrmrFeatures50] = feast('mrmr',50,points,cl);
[cmimFeatures50] = feast('cmim',50,points,cl);
[jmiFeatures50] = feast('jmi',50,points,cl);
[disrFeatures50] = feast('disr',50,points,cl);
[cifeFeatures50] = feast('cife',50,points,cl);
[icapFeatures50] = feast('icap',50,points,cl);
[condredFeatures50] = feast('condred',50,points,cl);
% [cmiFeatures50] = feast('cmi',50,points,cl);
% [reliefFeatures50] = feast('relief',50,points,cl);
allMethodFeature50 = [mimFeatures50 mrmrFeatures50 cmimFeatures50 jmiFeatures50 disrFeatures50 cifeFeatures50 icapFeatures50 condredFeatures50];
xlswrite('feastFeatures50.xlsx',allMethodFeature50,'allmethods');
uniqueIdx = unique(allMethodFeature50);
idxOccure = [uniqueIdx,histc(allMethodFeature50(:),uniqueIdx)];
sortedIdxOccure = sortrows(idxOccure,2,'descend');
xlswrite('feastFeatures50.xlsx',sortedIdxOccure, 'occurrence');

top30miRNAIdx = sort(sortedIdxOccure(1:30,1));
top30miRNA = miRNA(top30miRNAIdx);
expressData = points(:,top30miRNAIdx);
expressDatawithLabel = [expressData cl];
xlswrite('feastKidneyDataTop30.xlsx',top30miRNA,'top30','B1');
xlswrite('feastKidneyDataTop30.xlsx',patient,'top30','A2');
xlswrite('feastKidneyDataTop30.xlsx',expressDatawithLabel,'top30','B2');
